     /*
      * Copyright (c) 2007-2009 Mihael Schmidt
      * All rights reserved.
      *
      * This file is part of the JSON service program.
      *
      * JSON service program is free software: you can redistribute it and/or modify it under
      * the terms of the GNU Lesser General Public License as published by
      * the Free Software Foundation, either version 3 of the License, or
      * any later version.
      *
      * JSON service program is distributed in the hope that it will be useful,
      * but WITHOUT ANY WARRANTY; without even the implied warranty of
      * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      * GNU Lesser General Public License for more details.
      *
      * You should have received a copy of the GNU Lesser General Public
      * License along with JSON service program. If not, see http://www.gnu.org/licenses/.
      */


      *------------------------------------------------------------------------
      * Prototypes of internal procedures (shared among the modules)
      *------------------------------------------------------------------------
     D sendEscapeMessage...
     D                 PR
     D   id                          10I 0 const
      *
     D escapeLastToken...
     D                 PR
     D   tokenList                     *
      *
     D sendDiagnosticMessage...
     D                 PR
     D   message                    200A   const
      *
     D isJSONImpl...
     D                 PR
     D   jsonPtr                       *   const
      *
     D getJSONEntry    PR              *
     D   jsonPtr                       *   const
     D   keyPtr                        *   const
     D   keyLength                   10U 0 const
      *
     D disposeEntryValue...
     D                 PR
     D   entryPtr                      *
      *
     D prettyPrint     PR
     D   tokenList                     *   const
     D   printFormat                       const likeds(json_prettyPrintFormat)
     D   indentationLevel...
     D                               10I 0 const


      *-------------------------------------------------------------------------
      * Special Characters
      *-------------------------------------------------------------------------
     D tmpl_chars      DS                  qualified based(nullPointer)
     D  d_quote                       6A
     D  l_brace                       6A
     D  r_brace                       6A
     D  l_bracket                     6A
     D  r_bracket                     6A
     D  comma                         6A
     D  colon                         6A
     D  true                          6A
     D  false                         6A
     D  null_str                      6A
     D  size_d_quote...
     D                                5I 0
     D  size_l_brace...
     D                                5I 0
     D  size_r_brace...
     D                                5I 0
     D  size_l_bracket...
     D                                5I 0
     D  size_r_bracket...
     D                                5I 0
     D  size_comma...
     D                                5I 0
     D  size_colon...
     D                                5I 0
     D  size_true...
     D                                5I 0
     D  size_false...
     D                                5I 0
     D  size_null_str...
     D                                5I 0


      *-------------------------------------------------------------------------
      * Data Structures
      *-------------------------------------------------------------------------

     /*
      * If the json object has only one entry, the pointer for the firstand last
      * entry points to the same entry. If the list has no entries both pointers
      * has a *null value.
      *
      * <br><br>
      *
      * The field iteration has the default value of -1. It means that no
      * iteration is currently going on.
      *
      */
     D tmpl_header     DS                  qualified based(template)
     D   id                          20A
     D   size                        10U 0
     D   firstEntry                    *
     D   lastEntry                     *
     D   iteration                   10I 0
     D   iterNextEntry...
     D                                 *
     D   iterPrevEntry...
     D                                 *
     D   disposeList...
     D                                 *
      *
     D tmpl_entry      DS                  qualified based(template)
     D   type                        10I 0
     D   prev                          *
     D   next                          *
     D   key                           *
     D   keyLength                   10U 0
     D   value                         *
     D   valueLength                 10U 0
      *
     D tmpl_array_entry...
     D                 DS                  qualified
     D   type                        10I 0
     D   x                        65531A
     D   string                   65531A   overlay(x)
     D   boolean                       N   overlay(x)
     D   integer                     10I 0 overlay(x)
     D   long                        20I 0 overlay(x)
     D   double                       8F   overlay(x)
     D   object                        *   overlay(x : 13)
     D   array                         *   overlay(x : 13)


